public class Person implements Comparable {
    private String name;
    private String vorname;
    private int plz;
    private String strasse;
    private int hausnr;

    public Person(String name, String vorname, int plz, String strasse, int hausnr) {
        this.name = name;
	this.vorname = vorname;
	this.plz = plz;
	this.strasse = strasse;
	this.hausnr = hausnr;
    }

    public String gibName() {
        return this.name;
    }

    public String gibVorname() {
        return this.vorname;
    }

    public int gibPLZ() {
        return this.plz;
    }

    public String gibStrasse() {
        return this.strasse;
    }

    public int gibHausNummer() {
        return this.hausnr;
    }

    public String toString() {
        return this.name + ", " + this.vorname + ", " + this.plz + ", " +
	       this.strasse + " " + this.hausnr;
    }

    /*
     * Implementierung der Schnittstelle Comparable
     */
    public int compareTo(Object o) {
        Person p = (Person)o;		// Downcast notwendig, da sonst Instanzvariablen nicht sichtbar
	int    rc;			// wert eines Vergleichs

	if ( (rc=this.name.compareTo(p.name)) != 0) {		// wenn Namen ungleich
	    return rc;						// dann ist der Vergleich beendet
	}							// ansonsten Vergleich der Vornamen
	else if ( (rc=this.vorname.compareTo(p.vorname)) != 0) {	// wenn Vornamen ungleich
	    return rc;						// fertig
	}							// ansonsten Vergleich der PLZ
	else if ( (rc=this.plz-p.plz) != 0) {			// wenn PLZen ungleich
	    return rc;						// fertig
	}							// ansonsten Vergleich der Strasse
	else if ( (rc=this.strasse.compareTo(p.strasse)) != 0) {// wenn Strassen ungleich
	    return rc;						// fertig
	}							// ansonsten liefert Vergleich der Hausnummer
	else 							// das Ergebnis
	    return this.hausnr-p.hausnr;			// == 0, wenn auch Hausnummern gleich
    }
}
